; Sample Program
; Copyright  2014 Larry Charlton

	option casemap:none

	.nolist
	.nocref
WIN32_LEAN_AND_MEAN equ 1
	include	windows.inc
	.list
	.cref

	includelib <kernel32.lib>
	includelib <user32.lib>

INMODE	equ	(ENABLE_ECHO_INPUT or ENABLE_LINE_INPUT or ENABLE_PROCESSED_INPUT)
OUTMODE	equ	(ENABLE_PROCESSED_OUTPUT or ENABLE_WRAP_AT_EOL_OUTPUT)

.code
@con_in	proc uses rbx rsi rdi, pBuf:qword, bufSize:qword
; Returns: RAX = number of characters read
;-------------------------------------------------------------
 local	consoleoutoriginal :qword
 local	consoleinoriginal :qword
 local	charactersread :qword
;-------------------------------------------------------------
	mov	bufSize, rdx
	mov	pBuf, rcx

	invoke	GetStdHandle,STD_OUTPUT_HANDLE			; Get stdout
	mov	rsi, rax						; rsi = stdout

	invoke	GetStdHandle,STD_INPUT_HANDLE				; Get stdin
	mov	rbx, rax						; rbx = stdin

	invoke	GetConsoleMode, rsi, addr consoleoutoriginal		; Get stdout mode
	invoke	GetConsoleMode, rbx, addr consoleinoriginal		; Get stdin mode
	mov	rdx, OUTMODE					; rdx = OUTMODE
	cmp	rdx, consoleoutoriginal				; if OUTMODE != orginal console out mode
	jz	@con_in1
	invoke	SetConsoleMode, rsi, edx				; Set console out mode
@con_in1:
	mov	rdx, INMODE					; rdx = INMODE
	cmp	rdx, consoleinoriginal				; if INMODE != original console in mode
	jz	@con_in2
	invoke	SetConsoleMode, rbx, edx				; Set console in mode
@con_in2:
								; rbx = stdin
	mov	rdi, pBuf					; rdi = pointer to buffer
	mov	r10, bufSize					; r10d = buffer size
								; out number of characters read
	xor	r11, r11						; r11 = input control
	invoke	ReadConsole, rbx, rdi, r10d, addr charactersread, r11	; Get input
	mov	rdx, consoleoutoriginal				; rdx = original console out mode
	cmp	rdx, OUTMODE					; if original console out mode <> OUTMODE
	jz	@con_in3
	invoke	SetConsoleMode, rsi, edx				; Restore console out mode
@con_in3:
	mov	rdx, consoleinoriginal				; rdx = original console in mode
	cmp	rdx, INMODE					; if original console in mode <> INMODE
	jz	@con_in4
	invoke	SetConsoleMode, rbx, edx				; restore console in mode
@con_in4:
	xor	rax, rax						; rax = 0
	mov	eax, dword ptr [charactersread]			; eax = # of chars read
	sub	rax, 2						; remove cr/lf
	mov	TCHAR ptr [rdi+TCHAR*rax], 0				; terminating 0
	ret
@con_in endp
	end
