#Include This Once

Sub NewBufferOutput( obj As iOutput )
	obj = Class "cBufferOutput"
	If Not IsInterface( obj, iOutput ) Then
		MyPrint "Failed to create NewBufferOutput"
		End
	End If
End Sub

Function BufferOutput( obj As iOutput ) As String
	Local buf As iBufferOutput
	buf = obj
	If IsObject( buf ) Then
		Function = buf.Output
	End If
End Function


Class cBufferOutput
	Instance sb As IStringBuilderA

	Interface iOutput
		Inherit IUnknown

		Method Write( s As String )
			If Not IsObject( sb ) Then
				sb = Class "StringBuilderA"
			End If

			sb.Add( s )
		End Method

		Method WriteLine( s As String )
			If Not IsObject( sb ) Then
				sb = Class "StringBuilderA"
			End If

			sb.Add( s )
			sb.Add( $CrLf )
		End Method
	End Interface

	Interface iBufferOutput
		Inherit IUnknown

		Property Get Output As String
			If Not IsObject( sb ) Then
				sb = Class "StringBuilderA"
			End If

			Property = sb.String
		End Property
	End Interface
End Class
