#Include This Once

Enum SymbolType
	EndProgramSym
	OperatorSym
	NumberSym
	IdentifierSym
	IfSym
	ElseSym
	EndIfSym
	WhileSym
	WendSym
	InputSym
	PrintSym
	PrintLineSym
	DimSym
	AndSym
	OrSym
	XorSym
	NotSym
End Enum

Sub NewSymbols( ByRef obj As iSymbols )
	obj = Class "cSymbols"
	If Not IsInterface( obj, iSymbols ) Then
		MyPrint "Failed to create Symbols"
		End
	End If
End Sub

Class cSymbols
	Instance list As iStringLongMap
	Class Method Create()
		Call NewStringLongMap( list )
	End Method

	Interface iSymbols
		Inherit IUnknown
		Method CheckForDuplicate( symbol As String )
			If Me.Contains( symbol ) Then Call DuplicateError( symbol )
		End Method
		Method Add( newSymbol As String, newType As Long )
			' Add a new entry to symbol table
			Me.CheckForDuplicate( newSymbol )
			list.Add( newSymbol, newType )
		End Method
		Method Contains( symbol As String ) As Long
			Method = list.Contains( symbol )
		End Method
		Method Type( symbol As String ) As Long
			Method = list.Value( symbol )
		End Method
		Method Symbols() As String
			Local i As Long
			Local sb As IStringBuilderA
			sb = Class "StringBuilderA"
			For i=0 To list.Count()-1
				If i Then sb.Add( "," )
				sb.Add( list.Key( i ) )
			Next
			Method = sb.String
			sb = Nothing
		End Method
	End Interface
End Class
